<template>
  <div
    :class="{ office: isOffice } "
    v-if="auth">

    <flink
      v-if="isOffice"
      href="/cabinet/wrench/profile"
      domain="main"
      class="item"
      :class="{ active: navActive==='profile'}">
      <span class="title">Настройка</span>
      <span class="counter"/>
    </flink>

    <template v-if="auth.isOrganization">
      <flink
        href="/cabinet/price-upload/upload"
        domain="main"
        @click.native="openOrganizationLink($event); $ym('monolith_lk_link_click');"
        class="item desktopshow">
        <span :class="{ title: isOffice }">Мои прайсы</span>
        <span class="counter"/>
      </flink>
      <flink
        v-if="!isOffice"
        href="/cabinet/price-upload/history"
        domain="main"
        @click.native="openOrganizationLink($event); $ym('monolith_lk_link_click');"
        class="item desktopshow upload-history">
        <span class="text">История загрузок</span>
      </flink>
    </template>

    <flink
      :href="warehouseLink"
      domain="main"
      @click.native="openWarehouseLink($event); $ym('monolith_lk_link_click');"
      class="item group-end desktopshow">
      <span :class="{ title: isOffice }">Мой склад</span>
      <span class="counter"/>
    </flink>

    <template v-if="auth.isOrganization">
      <flink
        v-if="auth.organizationSended"
        @click.native="$ym('requests_in'); $ym('monolith_lk_link_click');"
        href="/cabinet/inbox"
        domain="main"
        class="item"
        :class="{ active: navActive==='inbox'}">
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/icons/i-profile-response.svg">
        </span>
        <span :class="{ title: isOffice }">Входящие запросы</span>
        <span
          v-if="counters.countNewIncomingRequests > 0"
          class="counter">
          {{ counters.countNewIncomingRequests }}
        </span>
      </flink>
      <span
        v-else
        @click="showInfoOrganizationSended"
        class="item"
        :class="{ disabled : !isOffice && !counters.countIncomingRequests }">
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/icons/i-profile-response.svg">
        </span>
        <span :class="{ title: isOffice }">Входящие запросы</span>
      </span>

      <flink
        href="/cabinet/outbox"
        domain="main"
        @click.native="$ym('requests_out'); $ym('monolith_lk_link_click');"
        class="item"
        :class="{ disabled : !isOffice && (counters.countOutgoingRequests === 0), active: navActive==='outbox' }">
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/icons/i-profile-incomming-req.svg">
        </span>
        <span :class="{ title: isOffice }">Исходящие запросы</span>
        <span
          v-if="counters.countNewOutgoingRequests > 0"
          class="counter">
          {{ counters.countNewOutgoingRequests }}
        </span>
      </flink>

      <flink
        href="/cabinet/reviews/about-me"
        domain="main"
        @click.native="$ym('monolith_lk_link_click')"
        class="item desktopshow"
        :class="{ disabled : !isOffice && !counters.hasAboutMeReviews &&
        !counters.hasMyReviews }">
        <span :class="{ title: isOffice }">Отзывы</span>
        <span
          v-if="counters.countUnreadReviews > 0"
          class="counter">
          {{ counters.countUnreadReviews }}
        </span>
      </flink>
    </template>

    <template v-else>
      <flink
        href="/cabinet/outbox"
        domain="main"
        @click.native="$ym('my_requests'); $ym('monolith_lk_link_click');"
        class="item desktopshow"
        :class="{ disabled : !isOffice && !counters.countOutgoingRequests }">
        <span :class="{ title: isOffice }">Мои запросы</span>
        <span
          v-if="counters.countNewOutgoingRequests > 0"
          class="counter">
          {{ counters.countNewOutgoingRequests }}
        </span>
      </flink>
      <flink
        href="/cabinet/reviews/my"
        domain="main"
        @click.native="$ym('monolith_lk_link_click')"
        class="item group-end desktopshow"
        :class="{ disabled : !isOffice && !counters.hasMyReviews }">
        <span :class="{ title: isOffice }">Мои отзывы</span>
      </flink>
    </template>

    <flink
      v-if="!isOffice"
      href="/cart"
      rel="nofollow"
      domain="main"
      class="item desktopshow group-end my-cart"
      :class="{ disabled : $store.getters['cart/counter'] === 0 }">
      <span class="text">Корзина</span>
      <span
        v-if="$store.getters['cart/counter']"
        class="notification">{{ $store.getters['cart/counter'] }}</span>
    </flink>

    <flink
      href="/cabinet/check-auto"
      domain="main"
      @click.native="$ym('monolith_lk_link_click')"
      class="item desktopshow">
      <span :class="{ title: isOffice }">Проверки авто</span>
      <span class="counter"/>
    </flink>

    <flink
      href="/cabinet/garage"
      domain="main"
      @click.native="$ym('monolith_lk_link_click')"
      class="item group-end desktopshow">
      <span :class="{ title: isOffice }">Гараж</span>
      <span class="counter"/>
    </flink>

    <flink
      v-if="!isOffice"
      href="/cabinet/garage/parts-searched"
      domain="main"
      @click.native="$ym('monolith_lk_link_click')"
      class="item group-end mobilshow">
      <span class="icon">
        <img
          svg-inline
          src="~/assets/svg/icons/i-profile-search-history.svg">
      </span>
      <span class="text">Вы искали</span>
    </flink>

    <flink
      v-if="hasStat"
      href="/cabinet/statistics/clicks"
      domain="main"
      class="item group-end desktopshow"
      :class="{ active: navActive==='statistics'}">
      <span :class="{ title: isOffice }">Статистика</span>
      <span class="counter"/>
    </flink>
  </div>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';
import { SHOW as INFO_MODAL_SHOW } from '~/assets/js/store/infoModal/action-types';

const STORE_INFO_MODAL = createNamespacedHelpers('infoModal');
const STORE_USER = createNamespacedHelpers('user');

export default {
  name: 'ProfileLinks',
  props: {
    isOffice: { /* !isOffice это profileSidebar */
      type: Boolean,
      default: false,
    },
    navActive: {
      type: String,
      default: null,
    },
  },
  computed: {
    ...STORE_USER.mapState(['auth', 'counters']),
    ...STORE_USER.mapGetters(['hasStat']),
    warehouseLink() {
      if (this.auth.isOrganization) {
        return '/cabinet/warehouse/new-parts';
      }
      return '/cabinet/warehouse/do-parts';
    },
  },
  methods: {
    ...STORE_INFO_MODAL.mapActions({
      showInfoModal: INFO_MODAL_SHOW,
    }),
    openOrganizationLink(event) {
      if (!this.auth.organizationSended) {
        this.showInfoOrganizationSended();
        event.preventDefault();
        return false;
      }

      if (!this.auth.isOrganizationWithShop) {
        this.showInfoWithShop();
        event.preventDefault();
        return false;
      }

      return true;
    },
    openWarehouseLink(event) {
      if (!this.auth.isCompleteProfile) {
        this.showInfoCompleteProfile();
        event.preventDefault();
        return false;
      }
      if (this.auth.isOrganization) {
        return this.openOrganizationLink(event);
      }
      return true;
    },
    showInfoOrganizationSended() {
      this.showInfoModal({
        text: 'Необходимо заполнить <br/> данные организации',
        buttonText: 'Перейти к заполнению',
        buttonUrl: '/cabinet/wrench/organization-info#/new',
        buttonDomain: 'main',
        buttonVisibility: true,
      });
      this.$ym('lk_modal_shown');
    },
    showInfoWithShop() {
      this.showInfoModal({
        text: 'Необходимо добавить магазин',
        buttonText: 'Перейти к добавлению',
        buttonUrl: '/cabinet/wrench/organization-sto/shop/create/',
        buttonDomain: 'main',
        buttonVisibility: true,
      });
      this.$ym('lk_modal_shown');
    },
    showInfoCompleteProfile() {
      this.showInfoModal({
        text: 'Необходимо заполнить профиль',
        buttonText: 'Перейти к заполнению',
        buttonUrl: '/cabinet/wrench/profile',
        buttonDomain: 'main',
        buttonVisibility: true,
      });
      this.$ym('lk_modal_shown');
    },
  },
};
</script>

<style scoped lang="scss">
  @import "~/assets/scss/modules/_profile-sidebar.scss";

  .office .item {
    display: flex;
    flex-flow: row nowrap;
    justify-content: space-between;
    align-items: center;
    width: 100%;
    height: 3rem;
    padding: 1rem 1rem 1rem 1.5rem;
    cursor: pointer;
    border-bottom: 1px solid #dbe4e9;
    &.active {
      background-color: #e4ebf6;
      pointer-events: none;
    }
    &:hover:not(.active) {
      > .title {
        color: #4272a4;
      }
    }
    > .title {
      display: block;
      font-size: 13px;
      line-height: 1.3;
      font-weight: 700;
      color: #272727;
      margin-right: auto;
    }
  }

  .counter {
    display: block;
    font-size: 13px;
    line-height: 1.3;
    font-weight: 400;
    color: #e13c3c;
    margin-left: auto;
  }
</style>
